![Logo sample by features](https://plugins.qgis.org/media/cache/3a/9c/3a9c4b36a8f11abeca6f4f8e2f87d24f.png)
--------------------------------------------------------------------------
# Sample by Area
The area sampling plan calculates the sample size (n) from the dimension of the area of interest (AOI). Thus, the population size (N) is the dimension of the area of interest, divided by the dimension of the inspection areas. The plugin is capable of working with isolated elements, in addition to continuous areas, generating a number of samples according to the statistical precepts present in ISO standards. Inspection level I, II or III indicates the degree of severity of the inspection. The Acceptable Quality Threshold (AQL) is the percentage of items not as desired in your dataset. This sampling plan is based on NBRs 5425, 5426 and 5427 (translations of the ISO 2859 series). According to the population size (N), the LQA and the inspection level, the sampling plan will indicate the sample size (n) and the acceptance (Ac) and rejection (Re) numbers for the data set to be evaluated. In the end, according to the percentage of non-conforming items desired (LQA), the user can approve or not his dataset.

--------------------------------------------------------------------------

#####Update: 
version 0.6:

- improved file name standardization. The file generated by this plugin, in shapefile format, is composed of the word "sample_area" plus "sample size" plus "sample plan type" (single "S"; double "D" and multiple "M") . The acceptance number (Ac) and the rejection number (Re) were added to the file name. For example: "sample _ area _ 32M _ Ac0 _ Re5" for a sample plan with 32 areas of inspection, from the multiple type, with the acceptance number being 0 rejected areas and the rejection number being 5 rejected areas

- added the recommended layer style for performing the quality inspection. The style is linked to the edit form and the symbology (qml file)

- added the metadata file, which appends additional information to the generated sampling plan, and allows the user to fill in the results at the end of the inspection in the properties of the generated layer itself (qmd file)

######version 0.5: 
- added the sampling plan type selection options (single, double or multiple) and the Acceptable Quality Limit (AQL) option
- added file name standardization. The file generated by this plugin, in shapefile format, is composed of the word "sample_area" plus "sample size" plus "sample plan type" (single "S"; double "D" and multiple "M" ). For example: "sample _ area _ 80M" for a sample plan with 80 areas of inspection, from the multiple type
- --------------------------------------------------------------------------
# Amostra por área
O plano de amostragem por área (camada) calcula o tamanho da amostra (n) a partir da dimensão da área de interesse (AOI) de inspeção . Desta forma, o tamanho da população (N) é a dimensão da área de interesse (AOI), dividida pela dimensão estipulada pelo usuário das áreas de inspeção (unidades de amostragem). O nível de inspeção I, II ou III indica o grau de severidade da inspeção. O Limite de Qualidade Aceitável (LQA) é o percetual de itens não conforme desejado no seu conjunto de dados. O plano de amostragem é baseado nas NBRs 5425, 5426 e 5427 (traduções da série ISO 2859). De acordo com o tamanho da população (N), o LQA e o nível de inspeção o plano de amostragem indicará o tamanho da amostra (n) e os números de aceitação (Ac) e receição (Re) para o conjunto de dados a ser avaliado. Ao final o usuário poderá aprovar o reprovar seu conjunto de dados, segundo o percentual de itens não conformes desejados (LQA). 

--------------------------------------------------------------------------
####Atualizações:
######versão 0.6:

-  O arquivo gerado por este plugin, em formato shapefile, é composto da palavra "sample_area" mais "o tamanho da amostra" mais o "tipo de plano de amostragem" (simples "S"; dupla "D" e múltipla "M").  Forma acrescentados ao nome do arquivo o número de aceitação (Ac) e o número de rejeição (Re). Por exemplo: "sample _ area _ 32M _ Ac0 _ Re5"

- adicionado o estilo recomendado para execução da inspeção de qualidade. O estilo está vinculado ao formulário de edição e a simbologia (arquivo qml).

- adicionado o arquivo de metadados para armazenar o plano de amostragem gerado, com informações complementares e propiciar ao usuário preencher os resultados no final da inspeção nas propriedades da própria camada gerada. (arquivo qmd). 

######versão 0.5: 

- No plugin foi adicionado as opções de seleção do tipo de plano de amostragem (simples, dupla ou múltipla) e a opção de seleção do Limite de Qualidade Aceitável (LQA). 

- No plugin foi adicionado as opções de seleção do tipo de plano de amostragem (simples, dupla ou múltipla) e a opção de seleção do Limite de Qualidade Aceitável (LQA). 

- O arquivo gerado por este plugin, em formato shapefile, é composto da palavra "sample_area" mais "o tamanho da amostra" mais o "tipo de plano de amostragem" (simples "S"; dupla "D" e múltipla "M").  Por exemplo: "sample _ area _ 80M"

##### por Alex Santos e Odair Martins